#region dashCommerce License
/*
dashCommerce is Copyright  2008-2012 Mettle Systems LLC. All Rights Reserved.


dashCommerce, and the dashCommerce logo are registered trademarks of Mettle Systems LLC. Mettle Systems LLC logos and trademarks may not be used without prior written consent.

dashCommerce is licensed under the following license. If you do not accept the terms, please discontinue the use of dashCommerce and uninstall dashCommerce. 

Your license to the dashCommerce source and/or binaries is governed by the Reciprocal Public License 1.5 (RPL1.5) license as described here: 

http://www.opensource.org/licenses/rpl1.5.txt 

If you do not wish to release the source of software you build using dashCommerce, you may purchase a site license, which will allow you to deploy dashCommerce for use in 1 web store defined as using 1 URL. You may purchase a site license here: 

http://www.dashcommerce.org/license.html 
*/
#endregion
using System;
using System.Collections.Generic;

namespace MettleSystems.dashCommerce.Store.Services {
  
  public class ProviderSettingsCollection : List<ProviderSettings> {

    #region Constructors
    
    /// <summary>
    /// Initializes a new instance of the <see cref="T:ProviderSettingsCollection"/> class.
    /// </summary>
    public ProviderSettingsCollection() : base() {
    }
    
    #endregion

    #region Methods

    /// <summary>
    /// Finds the specified provider name.
    /// </summary>
    /// <param name="providerName">Name of the provider.</param>
    /// <returns></returns>
    public int Find(string providerName) {
      for (int i = 0; i < this.Count; i++) {
        if (this[i].Name.Equals(providerName, StringComparison.OrdinalIgnoreCase))
          return i;
      }
      return -1;
    }

    /// <summary>
    /// Gets the <see cref="MettleSystems.dashCommerce.Store.Services.ProviderSettings"/> with the specified provider name.
    /// </summary>
    /// <value></value>
    public ProviderSettings this[string providerName] {
      get {
        int i = Find(providerName);
        if (i < 0)
          return null;
        return this[i];
      }
    }

    #endregion

  }
}
